/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.03  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Local headers */
#include "ablibs.h"
#include "abimport.h"
#include "proto.h"

/* devctl headers */ 
#include <sys/types.h>
#include <unistd.h>
#include <devctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "hitec.h"
#include "Legs.h"

#if (LEGS != MOTORS)
#error "LEGS != MOTORS"
#endif

int
SliderMove( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	int fd;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;
	
	if ((fd = open("/dev/hitec", O_RDONLY)) == -1) {
		perror("communication with hitec resmg failed");
	} else {
		data_t d;
		int i;
		
		for ( i = 0; i < MOTORS; i++) {
			long *pVal;
			PtGetResource(LegSizers[i], Pt_ARG_GAUGE_VALUE, &pVal, 0);
			d.tx_pos[i] = *pVal;
		}
		
		if (devctl(fd, HITEC_DEVCTL_SETVAL, &d, sizeof(d), NULL)) {
			perror("setting values failed");
		}
		close(fd);
	}	

	return( Pt_CONTINUE );

	}

