/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* devctl headers */
#include <sys/types.h>
#include <unistd.h>
#include <devctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "hitec.h"
#include "Legs.h"

#if (LEGS != MOTORS)
#error "LEGS != MOTORS"
#endif

step steptab[MAXSTEPS];

int
Import (const char *filename)
{

  FILE *in;
  int i;
  char buf[80];

  in = fopen (filename, "r");
  if (!in)
    {
      perror ("fopen()");
      return (-1);
    }

  i = 0;
  while (fgets (buf, sizeof (buf), in))
    {
      int r;
      r = sscanf (buf, "%lf %d %d %d %d %d %d %d %d\n",
	      &steptab[i].Ticks,
	      &steptab[i].Leg[0], &steptab[i].Leg[1], &steptab[i].Leg[2], &steptab[i].Leg[3],
	      &steptab[i].Leg[4], &steptab[i].Leg[5], &steptab[i].Leg[6], &steptab[i].Leg[7]);
      if (r != (1+LEGS)) {
      	printf("error reading file %s, line %d: %s", filename, i+1, buf);
	}
      i++;
    }

  fclose (in);

  return (i);
}

int
Move (int cnt)
{
  unsigned int delay_val;
  int fd;

  delay_val = steptab[cnt].Ticks * 1e3;

  if ((fd = open ("/dev/hitec", O_RDONLY)) == -1)
    {
      perror ("communication with hitec resmg failed");
    }
  else
    {
      data_t d;
      int i;

	//printf("%d:", cnt);
      for (i = 0; i < MOTORS; i++)
	{
	  //printf(" %d", steptab[cnt].Leg[i]);
	  d.tx_pos[i] = steptab[cnt].Leg[i];
	}
	//printf("\n");

      if (devctl (fd, HITEC_DEVCTL_SETVAL, &d, sizeof (d), NULL))
	{
	  perror ("setting values failed");
	}
      close (fd);
      
      delay(delay_val);
}

  return 0;
}

int
main (int argc, char *argv[])
{
  int i;

  if (argc < 2)
    {
      printf ("usage: %s pathfile ...\n", argv[0]);
      return 0;
    }

  for (i = 1; i < argc; i++)
    {
      int m, n;
      
      m = Import (argv[i]);
      
      if (m > 0)
	{
	  for (n = 0; n < m; n++) {
	  	//printf("plik %d, ruch %d\n", i, n);
	  	Move(n);
	  }
	};
    }

  return 0;
}

