#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <sys/select.h>

int
dev_raw (int fd)
{
    struct termios termios_p;

    if (tcgetattr (fd, &termios_p))
        return (-1);

    termios_p.c_cc[VMIN] = 1;
    termios_p.c_cc[VTIME] = 0;
    termios_p.c_lflag &= ~(ECHO | ICANON | ISIG |
        ECHOE | ECHOK | ECHONL);
    termios_p.c_oflag &= ~(OPOST);
    return (tcsetattr (fd, TCSANOW, &termios_p));
}

int
dev_unraw (int fd)
{
    struct termios termios_p;

    if (tcgetattr (fd, &termios_p))
        return (-1);

    termios_p.c_lflag |= (ECHO | ICANON | ISIG |
        ECHOE | ECHOK | ECHONL);
    termios_p.c_oflag |= (OPOST);
    return (tcsetattr (fd, TCSAFLUSH, &termios_p));
}

int
main(int argc, char *argv[])
{
	fd_set  rfds;
	int c;
	
    FD_ZERO (&rfds);
    
    FD_SET (STDIN_FILENO, &rfds);
    
    for (;;) {
		select(STDIN_FILENO+1, &rfds, NULL, NULL, NULL);
		
		if (FD_ISSET (STDIN_FILENO, &rfds)) {
			dev_raw (fileno (stdin));
 			c = getc (stdin);
            	dev_unraw (fileno (stdin));
	           if (c != EOF)
 	           {
	                switch (c)
	                {
					case 'q':
						printf("Q\n");
	                    break;
		               case 'a':
						printf("A\n");
 	                    break;
	                }
 	           } else {
 	           	break;
           	}
           	printf("_%c_\n", c);
		}
    }
    
	return 0;
}
